Calendar

- Main Page
- Related Pages
- Data Structures
- Files
- Examples

Typedefs | Enumerations | Functions
Calendar

## Typedefs
typedef struct _Elm_Calendar_Mark | Elm_Calendar_Mark
| Item handle for a calendar mark. More...
typedef char *(* | Elm_Calendar_Format_Cb) (struct tm *stime)
| This callback type is used to format the string that will be used to display month and year. More...

## Enumerations
enum | Elm_Calendar_Mark_Repeat_Type { ELM_CALENDAR_UNIQUE, ELM_CALENDAR_DAILY, ELM_CALENDAR_WEEKLY, ELM_CALENDAR_MONTHLY, ELM_CALENDAR_ANNUALLY, ELM_CALENDAR_LAST_DAY_OF_MONTH }
| Event periodicity, used to define if a mark should be repeated beyond event's day. More...
enum | Elm_Calendar_Weekday
| A weekday. More...
enum | Elm_Calendar_Select_Mode { ELM_CALENDAR_SELECT_MODE_DEFAULT = 0, ELM_CALENDAR_SELECT_MODE_ALWAYS, ELM_CALENDAR_SELECT_MODE_NONE, ELM_CALENDAR_SELECT_MODE_ONDEMAND }
| The mode, who determine how user could select a day. More...
enum | Elm_Calendar_Selectable

## Functions
EOAPI void | elm_obj_calendar_first_day_of_week_set (Elm_Calendar_Weekday day)
| Set the first day of week to use on calendar widgets'. More...
EOAPI Elm_Calendar_Weekday | elm_obj_calendar_first_day_of_week_get (void)
| Get the first day of week, who are used on calendar widgets'. More...
EOAPI void | elm_obj_calendar_selectable_set (Elm_Calendar_Selectable selectable)
| Define which fields of a tm struct will be taken into account, when elm_calendar_selected_time_set() is invoked. More...
EOAPI Elm_Calendar_Selectable | elm_obj_calendar_selectable_get (void)
| Get how elm_calendar_selected_time_set manage a date. More...
EOAPI void | elm_obj_calendar_interval_set (double interval)
| Set the interval on time updates for an user mouse button hold on calendar widgets' month/year selection. More...
EOAPI double | elm_obj_calendar_interval_get (void)
| Get the interval on time updates for an user mouse button hold on calendar widgets' month/year selection. More...
EOAPI void | elm_obj_calendar_weekdays_names_set (const char **weekdays)
| Set weekdays names to be displayed by the calendar. More...
EOAPI const char ** | elm_obj_calendar_weekdays_names_get (void)
| Get weekdays names displayed by the calendar. More...
EOAPI void | elm_obj_calendar_select_mode_set (Elm_Calendar_Select_Mode mode)
| Set select day mode to use. More...
EOAPI Elm_Calendar_Select_Mode | elm_obj_calendar_select_mode_get (void)
| Get the select day mode used. More...
EOAPI void | elm_obj_calendar_min_max_year_set (int min, int max)
| Set the minimum and maximum values for the year. More...
EOAPI void | elm_obj_calendar_min_max_year_get (int *min, int *max)
| Get the minimum and maximum values for the year. More...
EOAPI void | elm_obj_calendar_format_function_set (Elm_Calendar_Format_Cb format_function)
| Set a function to format the string that will be used to display month and year;. More...
EOAPI const Eina_List * | elm_obj_calendar_marks_get (void)
| Get a list of all the calendar marks. More...
EOAPI void | elm_obj_calendar_selected_time_set (struct tm *selected_time)
| Set selected date to be highlighted on calendar. More...
EOAPI Eina_Bool | elm_obj_calendar_selected_time_get (struct tm *selected_time)
| Get selected date. More...
EOAPI Elm_Calendar_Mark * | elm_obj_calendar_mark_add (const char *mark_type, struct tm *mark_time, Elm_Calendar_Mark_Repeat_Type repeat)
| Add a new mark to the calendar. More...
EOAPI void | elm_obj_calendar_marks_clear (void)
| Remove all calendar's marks. More...
EOAPI void | elm_obj_calendar_marks_draw (void)
| Draw calendar marks. More...
EOAPI Eina_Bool | elm_obj_calendar_displayed_time_get (struct tm *displayed_time)
| Get the current time displayed in the widget. More...
void | elm_calendar_first_day_of_week_set (Elm_Calendar *obj, Elm_Calendar_Weekday day)
| Set the first day of week to use on calendar widgets'. More...
Elm_Calendar_Weekday | elm_calendar_first_day_of_week_get (const Elm_Calendar *obj)
| Get the first day of week, who are used on calendar widgets'. More...
void | elm_calendar_selectable_set (Elm_Calendar *obj, Elm_Calendar_Selectable selectable)
| Define which fields of a tm struct will be taken into account, when elm_calendar_selected_time_set() is invoked. More...
Elm_Calendar_Selectable | elm_calendar_selectable_get (const Elm_Calendar *obj)
| Get how elm_calendar_selected_time_set manage a date. More...
void | elm_calendar_interval_set (Elm_Calendar *obj, double interval)
| Set the interval on time updates for an user mouse button hold on calendar widgets' month/year selection. More...
double | elm_calendar_interval_get (const Elm_Calendar *obj)
| Get the interval on time updates for an user mouse button hold on calendar widgets' month/year selection. More...
void | elm_calendar_weekdays_names_set (Elm_Calendar *obj, const char **weekdays)
| Set weekdays names to be displayed by the calendar. More...
const char ** | elm_calendar_weekdays_names_get (const Elm_Calendar *obj)
| Get weekdays names displayed by the calendar. More...
void | elm_calendar_select_mode_set (Elm_Calendar *obj, Elm_Calendar_Select_Mode mode)
| Set select day mode to use. More...
Elm_Calendar_Select_Mode | elm_calendar_select_mode_get (const Elm_Calendar *obj)
| Get the select day mode used. More...
void | elm_calendar_min_max_year_set (Elm_Calendar *obj, int min, int max)
| Set the minimum and maximum values for the year. More...
void | elm_calendar_min_max_year_get (const Elm_Calendar *obj, int *min, int *max)
| Get the minimum and maximum values for the year. More...
void | elm_calendar_format_function_set (Elm_Calendar *obj, Elm_Calendar_Format_Cb format_function)
| Set a function to format the string that will be used to display month and year;. More...
const Eina_List * | elm_calendar_marks_get (const Elm_Calendar *obj)
| Get a list of all the calendar marks. More...
void | elm_calendar_selected_time_set (Elm_Calendar *obj, struct tm *selected_time)
| Set selected date to be highlighted on calendar. More...
Eina_Bool | elm_calendar_selected_time_get (const Elm_Calendar *obj, struct tm *selected_time)
| Get selected date. More...
Elm_Calendar_Mark * | elm_calendar_mark_add (Elm_Calendar *obj, const char *mark_type, struct tm *mark_time, Elm_Calendar_Mark_Repeat_Type repeat)
| Add a new mark to the calendar. More...
void | elm_calendar_marks_clear (Elm_Calendar *obj)
| Remove all calendar's marks. More...
void | elm_calendar_marks_draw (Elm_Calendar *obj)
| Draw calendar marks. More...
Eina_Bool | elm_calendar_displayed_time_get (const Elm_Calendar *obj, struct tm *displayed_time)
| Get the current time displayed in the widget. More...
void | elm_calendar_weekdays_names_set (Evas_Object *obj, const char *weekdays[])
| Set weekdays names to be displayed by the calendar. More...
void | elm_calendar_mark_del (Elm_Calendar_Mark *mark)
| Delete mark from the calendar. More...
Evas_Object * | elm_calendar_add (Evas_Object *parent)
| Add a new calendar widget to the given parent Elementary (container) object. More...

## Detailed Description

This is a calendar widget. It helps applications to flexibly display a calender with day of the week, date, year and month. Applications are able to set specific dates to be reported back, when selected, in the smart callbacks of the calendar widget. The API of this widget lets the applications perform other functions, like:

- placing marks on specific dates
- setting the bounds for the calendar (minimum and maximum years)
- setting the day names of the week (e.g. "Thu" or "Thursday")
- setting the year and month format.

This widget inherits from the Layout one, so that all the functions acting on it also work for calendar objects.

This widget emits the following signals, besides the ones sent from Layout:

- `"changed"` - emitted when the date in the calendar is changed.
- `"display,changed"` - emitted when the current month displayed in the calendar is changed.
- `"focused"` - When the calendar has received focus. (since 1.8)
- `"unfocused"` - When the calendar has lost focus. (since 1.8)
- `"language,changed"` - the program's language changed (since 1.9)

Supported elm_object common APIs.

- elm_object_signal_emit
- elm_object_signal_callback_add
- elm_object_signal_callback_del

Here is some sample code using it:

- Calendar - Simple creation.
- Calendar - Layout strings formatting.
- Calendar - Years restrictions.
- Calendar - Days selection.
- Calendar - Signal callback and getters.
- Calendar - Calendar marks.

## Typedef Documentation

typedef char*(* Elm_Calendar_Format_Cb) (struct tm *stime)

This callback type is used to format the string that will be used to display month and year.

Parameters

  stime | Struct representing time.

Returns
  String representing time that will be set to calendar's text.

See also
  elm_calendar_format_function_set()

typedef struct _Elm_Calendar_Mark Elm_Calendar_Mark

Item handle for a calendar mark.

Created with elm_calendar_mark_add() and deleted with elm_calendar_mark_del().

## Enumeration Type Documentation

enum Elm_Calendar_Mark_Repeat_Type

Event periodicity, used to define if a mark should be repeated beyond event's day.

It's set when a mark is added.

So, for a mark added to 13th May with periodicity set to WEEKLY, there will be marks every week after this date. Marks will be displayed at 13th, 20th, 27th, 3rd June ...

Values don't work as bitmask, only one can be chosen.

See also
  elm_calendar_mark_add()

Enumerator
ELM_CALENDAR_UNIQUE | Default value. Marks will be displayed only on event day.
ELM_CALENDAR_DAILY | Marks will be displayed every day after event day (inclusive).
ELM_CALENDAR_WEEKLY | Marks will be displayed every week after event day (inclusive) - i.e. each seven days.
ELM_CALENDAR_MONTHLY | Marks will be displayed every month day that coincides to event day. E.g.: if an event is set to 30th Jan, no marks will be displayed on Feb, but will be displayed on 30th Mar
ELM_CALENDAR_ANNUALLY | Marks will be displayed every year that coincides to event day (and month). E.g. an event added to 30th Jan 2012 will be repeated on 30th Jan 2013.
ELM_CALENDAR_LAST_DAY_OF_MONTH | Marks will be displayed every last day of month after event day (inclusive). Since 1.7

enum Elm_Calendar_Select_Mode

The mode, who determine how user could select a day.

See also
  elm_calendar_select_mode_set()

Enumerator
ELM_CALENDAR_SELECT_MODE_DEFAULT | Default value. a day is always selected.
ELM_CALENDAR_SELECT_MODE_ALWAYS | a day is always selected.
ELM_CALENDAR_SELECT_MODE_NONE | None of the days can be selected.
ELM_CALENDAR_SELECT_MODE_ONDEMAND | User may have selected a day or not.

enum Elm_Calendar_Selectable

A bitmask used to define which fields of a tm struct will be taken into account, when elm_calendar_selected_time_set() is invoked.

See also
  elm_calendar_selectable_set()
  elm_calendar_selected_time_set()

Since
  1.8

enum Elm_Calendar_Weekday

A weekday.

See also
  elm_calendar_first_day_of_week_set()

## Function Documentation

Evas_Object* elm_calendar_add | ( | Evas_Object * | parent | ) |

Add a new calendar widget to the given parent Elementary (container) object.

Parameters

  parent | The parent object.

Returns
  a new calendar widget handle or `NULL`, on errors.

This function inserts a new calendar widget on the canvas.

Calendar - Simple creation.

Eina_Bool elm_calendar_displayed_time_get | ( | const Elm_Calendar * | obj,
|  | struct tm * | displayed_time
| ) |  |

Get the current time displayed in the widget.

Returns
  EINA_FALSE means an error occurred. If it's an error the returned time is zero filled.

Since
  1.8

Parameters

  [in,out] | displayed_time | A tm struct to point to displayed date

References elm_obj_calendar_displayed_time_get().

Elm_Calendar_Weekday elm_calendar_first_day_of_week_get | ( | const Elm_Calendar * | obj | ) |

Get the first day of week, who are used on calendar widgets'.

Returns
  An int which correspond to the first day of the week (Sunday = 0, Monday = 1, ..., Saturday = 6)

See also
  elm_calendar_first_day_of_week_set() for more details

References elm_obj_calendar_first_day_of_week_get().

void elm_calendar_first_day_of_week_set | ( | Elm_Calendar * | obj,
|  | Elm_Calendar_Weekday | day
| ) |  |

Set the first day of week to use on calendar widgets'.

Parameters

  [in] | day | An int which correspond to the first day of the week (Sunday = 0, Monday = 1, ..., Saturday = 6)

References elm_obj_calendar_first_day_of_week_set().

void elm_calendar_format_function_set | ( | Elm_Calendar * | obj,
|  | Elm_Calendar_Format_Cb | format_function
| ) |  |

Set a function to format the string that will be used to display month and year;.

By default it uses strftime with "%B %Y" format string. It should allocate the memory that will be used by the string, that will be freed by the widget after usage. A pointer to the string and a pointer to the time struct will be provided.

Example:

1 static char
2 _format_month_year(struct tm *selected_time)
3 {
4 char buf[32];
5 if (!strftime(buf, sizeof(buf), "%B %Y", selected_time)) return NULL;
6 return strdup(buf);
7 }
8
9 elm_calendar_format_function_set(calendar, _format_month_year);

Calendar - Layout strings formatting.

Parameters

  [in] | format_function | Function to set the month-year string given the selected date

References elm_obj_calendar_format_function_set().

double elm_calendar_interval_get | ( | const Elm_Calendar * | obj | ) |

Get the interval on time updates for an user mouse button hold on calendar widgets' month/year selection.

Returns
  The (first) interval value, in seconds, set on it

See also
  elm_calendar_interval_set() for more details

References elm_obj_calendar_interval_get().

void elm_calendar_interval_set | ( | Elm_Calendar * | obj,
|  | double | interval
| ) |  |

Set the interval on time updates for an user mouse button hold on calendar widgets' month/year selection.

This interval value is decreased while the user holds the mouse pointer either selecting next or previous month/year.

This helps the user to get to a given month distant from the current one easier/faster, as it will start to change quicker and quicker on mouse button holds.

The calculation for the next change interval value, starting from the one set with this call, is the previous interval divided by 1.05, so it decreases a little bit.

The default starting interval value for automatic changes is 0.85 seconds.

See also
  elm_calendar_interval_get()

Parameters

  [in] | interval | The (first) interval value in seconds

References elm_obj_calendar_interval_set().

Elm_Calendar_Mark* elm_calendar_mark_add | ( | Elm_Calendar * | obj,
|  | const char * | mark_type,
|  | struct tm * | mark_time,
|  | Elm_Calendar_Mark_Repeat_Type | repeat
| ) |  |

Add a new mark to the calendar.

Returns
  The created mark or `NULL` upon failure.

Add a mark that will be drawn in the calendar respecting the insertion time and periodicity. It will emit the type as signal to the widget theme. Default theme supports "holiday" and "checked", but it can be extended.

It won't immediately update the calendar, drawing the marks. For this, call elm_calendar_marks_draw(). However, when user selects next or previous month calendar forces marks drawn.

Marks created with this method can be deleted with elm_calendar_mark_del().

Example

1 struct tm selected_time;
2 time_t current_time;
3
4 current_time = time(NULL) + 5 * (24 * 60 * 60);
5 localtime_r(&current_time, &selected_time);
6 elm_calendar_mark_add(cal, "holiday", selected_time,
7 ELM_CALENDAR_ANNUALLY);
8
9 current_time = time(NULL) + 1 * (24 * 60 * 60);
10 localtime_r(&current_time, &selected_time);
11 elm_calendar_mark_add(cal, "checked", selected_time, ELM_CALENDAR_UNIQUE);
12
13 elm_calendar_marks_draw(cal);

See also
  elm_calendar_marks_draw()
  elm_calendar_mark_del()

Calendar - Calendar marks.

Parameters

  [in] | mark_type | A string used to define the type of mark. It will be emitted to the theme, that should display a related modification on these days representation.
  [in] | mark_time | A time struct to represent the date of inclusion of the mark. For marks that repeats it will just be displayed after the inclusion date in the calendar.
  [in] | repeat | Repeat the event following this periodicity. Can be a unique mark (that don't repeat), daily, weekly, monthly or annually.

References elm_obj_calendar_mark_add().

void elm_calendar_mark_del | ( | Elm_Calendar_Mark * | mark | ) |

Delete mark from the calendar.

Parameters

  mark | The mark to be deleted.

If deleting all calendar marks is required, elm_calendar_marks_clear() should be used instead of getting marks list and deleting each one.

See also
  elm_calendar_mark_add()

Calendar - Calendar marks.

void elm_calendar_marks_clear | ( | Elm_Calendar * | obj | ) |

Remove all calendar's marks.

See also
  elm_calendar_mark_add()
  elm_calendar_mark_del()

References elm_obj_calendar_marks_clear().

void elm_calendar_marks_draw | ( | Elm_Calendar * | obj | ) |

Draw calendar marks.

Should be used after adding, removing or clearing marks. It will go through the entire marks list updating the calendar. If lots of marks will be added, add all the marks and then call this function.

When the month is changed, i.e. user selects next or previous month, marks will be drawn.

See also
  elm_calendar_mark_add()
  elm_calendar_mark_del()
  elm_calendar_marks_clear()

Calendar - Calendar marks.

References elm_obj_calendar_marks_draw().

const Eina_List* elm_calendar_marks_get | ( | const Elm_Calendar * | obj | ) |

Get a list of all the calendar marks.

Returns
  A `list` of calendar marks objects, or `NULL` on failure.

See also
  elm_calendar_mark_add()
  elm_calendar_mark_del()
  elm_calendar_marks_clear()

References elm_obj_calendar_marks_get().

void elm_calendar_min_max_year_get | ( | const Elm_Calendar * | obj,
|  | int * | min,
|  | int * | max
| ) |  |

Get the minimum and maximum values for the year.

Default values are 1902 and -1.

See also
  elm_calendar_min_max_year_set() for more details.

Calendar - Signal callback and getters.

Parameters

  [out] | min | The minimum year, greater than 1901;
  [out] | max | The maximum year;

References elm_obj_calendar_min_max_year_get().

void elm_calendar_min_max_year_set | ( | Elm_Calendar * | obj,
|  | int | min,
|  | int | max
| ) |  |

Set the minimum and maximum values for the year.

Maximum must be greater than minimum, except if you don't want to set maximum year. Default values are 1902 and -1.

If the maximum year is a negative value, it will be limited depending on the platform architecture (year 2037 for 32 bits);

See also
  elm_calendar_min_max_year_get()

Calendar - Years restrictions.

Parameters

  [in] | min | The minimum year, greater than 1901;
  [in] | max | The maximum year;

References elm_obj_calendar_min_max_year_set().

Elm_Calendar_Select_Mode elm_calendar_select_mode_get | ( | const Elm_Calendar * | obj | ) |

Get the select day mode used.

Returns
  the selected mode

Get the day selection mode used.

See also
  elm_calendar_select_mode_set() for more details

References elm_obj_calendar_select_mode_get().

void elm_calendar_select_mode_set | ( | Elm_Calendar * | obj,
|  | Elm_Calendar_Select_Mode | mode
| ) |  |

Set select day mode to use.

Set the day selection mode used.

Parameters

  [in] | mode | The select mode to use.

References elm_obj_calendar_select_mode_set().

Elm_Calendar_Selectable elm_calendar_selectable_get | ( | const Elm_Calendar * | obj | ) |

Get how elm_calendar_selected_time_set manage a date.

Returns
  The flag used to manage a date with a elm_calendar_selected_time_set

See also
  elm_calendar_selectable_set
  elm_calendar_selected_time_set

Since
  1.8

References elm_obj_calendar_selectable_get().

void elm_calendar_selectable_set | ( | Elm_Calendar * | obj,
|  | Elm_Calendar_Selectable | selectable
| ) |  |

Define which fields of a tm struct will be taken into account, when elm_calendar_selected_time_set() is invoked.

By Default the bitmask is set to use all fields of a tm struct (year, month and day of the month).

See also
  elm_calendar_selected_time_set

Since
  1.8

Parameters

  [in] | selectable | A bitmask of Elm_Calendar_Selectable

References elm_obj_calendar_selectable_set().

Eina_Bool elm_calendar_selected_time_get | ( | const Elm_Calendar * | obj,
|  | struct tm * | selected_time
| ) |  |

Get selected date.

Returns
  EINA_FALSE means an error occurred and returned time shouldn't be considered.

Get date selected by the user or set by function elm_calendar_selected_time_set(). Selected date changes when the user goes to next/previous month or select a day pressing over it on calendar.

See also
  elm_calendar_selected_time_get()

Calendar - Signal callback and getters.

Parameters

  [in,out] | selected_time | A tm struct to point to selected date

References elm_obj_calendar_selected_time_get().

void elm_calendar_selected_time_set | ( | Elm_Calendar * | obj,
|  | struct tm * | selected_time
| ) |  |

Set selected date to be highlighted on calendar.

Set the selected date, changing the displayed month if needed. Selected date changes when the user goes to next/previous month or select a day pressing over it on calendar.

See also
  elm_calendar_selected_time_get()

Calendar - Days selection.

Parameters

  [in] | selected_time | A tm struct to represent the selected date.

References elm_obj_calendar_selected_time_set().

const char** elm_calendar_weekdays_names_get | ( | const Elm_Calendar * | obj | ) |

Get weekdays names displayed by the calendar.

Returns
  Array of seven strings to be used as weekday names.

By default, weekdays abbreviations get from system are displayed: E.g. for an en_US locale: "Sun, Mon, Tue, Wed, Thu, Fri, Sat" The first string is related to Sunday, the second to Monday...

See also
  elm_calendar_weekdays_name_set()

Calendar - Signal callback and getters.

References elm_obj_calendar_weekdays_names_get().

void elm_calendar_weekdays_names_set | ( | Evas_Object * | obj,
|  | const char * | weekdays[]
| ) |  |

Set weekdays names to be displayed by the calendar.

Parameters

  obj | The calendar object.
  weekdays | Array of seven strings to be used as weekday names.

Warning
  It must have 7 elements, or it will access invalid memory.
  The strings must be NULL terminated ('\0').

By default, weekdays abbreviations get from system are displayed: E.g. for an en_US locale: "Sun, Mon, Tue, Wed, Thu, Fri, Sat"

The first string should be related to Sunday, the second to Monday...

The usage should be like this:

1 const char *weekdays[] =
2 {
3 "Sunday", "Monday", "Tuesday", "Wednesday",
4 "Thursday", "Friday", "Saturday"
5 };
6 elm_calendar_weekdays_names_set(calendar, weekdays);

See also
  elm_calendar_weekdays_name_get()

Calendar - Layout strings formatting.

void elm_calendar_weekdays_names_set | ( | Elm_Calendar * | obj,
|  | const char ** | weekdays
| ) |  |

Set weekdays names to be displayed by the calendar.

By default, weekdays abbreviations get from system are displayed: E.g. for an en_US locale: "Sun, Mon, Tue, Wed, Thu, Fri, Sat"

The first string should be related to Sunday, the second to Monday...

The usage should be like this:

1 const char *weekdays[] =
2 {
3 "Sunday", "Monday", "Tuesday", "Wednesday",
4 "Thursday", "Friday", "Saturday"
5 };
6 elm_calendar_weekdays_names_set(calendar, weekdays);

See also
  elm_calendar_weekdays_name_get()

Calendar - Layout strings formatting.

Parameters

  [in] | weekdays | Array of seven strings to be used as weekday names.

Warning
  It must have 7 elements, or it will access invalid memory.
  The strings must be NULL terminated ('\0').

References elm_obj_calendar_weekdays_names_set().

EOAPI Eina_Bool elm_obj_calendar_displayed_time_get | ( | struct tm * | displayed_time | ) |

Get the current time displayed in the widget.

Returns
  EINA_FALSE means an error occurred. If it's an error the returned time is zero filled.

Since
  1.8

Parameters

  [in,out] | displayed_time | A tm struct to point to displayed date

Referenced by elm_calendar_displayed_time_get().

EOAPI Elm_Calendar_Weekday elm_obj_calendar_first_day_of_week_get | ( | void |  | ) |

Get the first day of week, who are used on calendar widgets'.

Returns
  An int which correspond to the first day of the week (Sunday = 0, Monday = 1, ..., Saturday = 6)

See also
  elm_calendar_first_day_of_week_set() for more details

Referenced by elm_calendar_first_day_of_week_get().

EOAPI void elm_obj_calendar_first_day_of_week_set | ( | Elm_Calendar_Weekday | day | ) |

Set the first day of week to use on calendar widgets'.

Parameters

  [in] | day | An int which correspond to the first day of the week (Sunday = 0, Monday = 1, ..., Saturday = 6)

Referenced by elm_calendar_first_day_of_week_set().

EOAPI void elm_obj_calendar_format_function_set | ( | Elm_Calendar_Format_Cb | format_function | ) |

Set a function to format the string that will be used to display month and year;.

By default it uses strftime with "%B %Y" format string. It should allocate the memory that will be used by the string, that will be freed by the widget after usage. A pointer to the string and a pointer to the time struct will be provided.

Example:

1 static char
2 _format_month_year(struct tm *selected_time)
3 {
4 char buf[32];
5 if (!strftime(buf, sizeof(buf), "%B %Y", selected_time)) return NULL;
6 return strdup(buf);
7 }
8
9 elm_calendar_format_function_set(calendar, _format_month_year);

Calendar - Layout strings formatting.

Parameters

  [in] | format_function | Function to set the month-year string given the selected date

Referenced by elm_calendar_format_function_set().

EOAPI double elm_obj_calendar_interval_get | ( | void |  | ) |

Get the interval on time updates for an user mouse button hold on calendar widgets' month/year selection.

Returns
  The (first) interval value, in seconds, set on it

See also
  elm_calendar_interval_set() for more details

Referenced by elm_calendar_interval_get().

EOAPI void elm_obj_calendar_interval_set | ( | double | interval | ) |

Set the interval on time updates for an user mouse button hold on calendar widgets' month/year selection.

This interval value is decreased while the user holds the mouse pointer either selecting next or previous month/year.

This helps the user to get to a given month distant from the current one easier/faster, as it will start to change quicker and quicker on mouse button holds.

The calculation for the next change interval value, starting from the one set with this call, is the previous interval divided by 1.05, so it decreases a little bit.

The default starting interval value for automatic changes is 0.85 seconds.

See also
  elm_calendar_interval_get()

Parameters

  [in] | interval | The (first) interval value in seconds

Referenced by elm_calendar_interval_set().

EOAPI Elm_Calendar_Mark* elm_obj_calendar_mark_add | ( | const char * | mark_type,
|  | struct tm * | mark_time,
|  | Elm_Calendar_Mark_Repeat_Type | repeat
| ) |  |

Add a new mark to the calendar.

Returns
  The created mark or `NULL` upon failure.

Add a mark that will be drawn in the calendar respecting the insertion time and periodicity. It will emit the type as signal to the widget theme. Default theme supports "holiday" and "checked", but it can be extended.

It won't immediately update the calendar, drawing the marks. For this, call elm_calendar_marks_draw(). However, when user selects next or previous month calendar forces marks drawn.

Marks created with this method can be deleted with elm_calendar_mark_del().

Example

1 struct tm selected_time;
2 time_t current_time;
3
4 current_time = time(NULL) + 5 * (24 * 60 * 60);
5 localtime_r(&current_time, &selected_time);
6 elm_calendar_mark_add(cal, "holiday", selected_time,
7 ELM_CALENDAR_ANNUALLY);
8
9 current_time = time(NULL) + 1 * (24 * 60 * 60);
10 localtime_r(&current_time, &selected_time);
11 elm_calendar_mark_add(cal, "checked", selected_time, ELM_CALENDAR_UNIQUE);
12
13 elm_calendar_marks_draw(cal);

See also
  elm_calendar_marks_draw()
  elm_calendar_mark_del()

Calendar - Calendar marks.

Parameters

  [in] | mark_type | A string used to define the type of mark. It will be emitted to the theme, that should display a related modification on these days representation.
  [in] | mark_time | A time struct to represent the date of inclusion of the mark. For marks that repeats it will just be displayed after the inclusion date in the calendar.
  [in] | repeat | Repeat the event following this periodicity. Can be a unique mark (that don't repeat), daily, weekly, monthly or annually.

Referenced by elm_calendar_mark_add().

EOAPI void elm_obj_calendar_marks_clear | ( | void |  | ) |

Remove all calendar's marks.

See also
  elm_calendar_mark_add()
  elm_calendar_mark_del()

Referenced by elm_calendar_marks_clear().

EOAPI void elm_obj_calendar_marks_draw | ( | void |  | ) |

Draw calendar marks.

Should be used after adding, removing or clearing marks. It will go through the entire marks list updating the calendar. If lots of marks will be added, add all the marks and then call this function.

When the month is changed, i.e. user selects next or previous month, marks will be drawn.

See also
  elm_calendar_mark_add()
  elm_calendar_mark_del()
  elm_calendar_marks_clear()

Calendar - Calendar marks.

Referenced by elm_calendar_marks_draw().

EOAPI const Eina_List* elm_obj_calendar_marks_get | ( | void |  | ) |

Get a list of all the calendar marks.

Returns
  A `list` of calendar marks objects, or `NULL` on failure.

See also
  elm_calendar_mark_add()
  elm_calendar_mark_del()
  elm_calendar_marks_clear()

Referenced by elm_calendar_marks_get().

EOAPI void elm_obj_calendar_min_max_year_get | ( | int * | min,
|  | int * | max
| ) |  |

Get the minimum and maximum values for the year.

Default values are 1902 and -1.

See also
  elm_calendar_min_max_year_set() for more details.

Calendar - Signal callback and getters.

Parameters

  [out] | min | The minimum year, greater than 1901;
  [out] | max | The maximum year;

Referenced by elm_calendar_min_max_year_get().

EOAPI void elm_obj_calendar_min_max_year_set | ( | int | min,
|  | int | max
| ) |  |

Set the minimum and maximum values for the year.

Maximum must be greater than minimum, except if you don't want to set maximum year. Default values are 1902 and -1.

If the maximum year is a negative value, it will be limited depending on the platform architecture (year 2037 for 32 bits);

See also
  elm_calendar_min_max_year_get()

Calendar - Years restrictions.

Parameters

  [in] | min | The minimum year, greater than 1901;
  [in] | max | The maximum year;

Referenced by elm_calendar_min_max_year_set().

EOAPI Elm_Calendar_Select_Mode elm_obj_calendar_select_mode_get | ( | void |  | ) |

Get the select day mode used.

Returns
  the selected mode

Get the day selection mode used.

See also
  elm_calendar_select_mode_set() for more details

Referenced by elm_calendar_select_mode_get().

EOAPI void elm_obj_calendar_select_mode_set | ( | Elm_Calendar_Select_Mode | mode | ) |

Set select day mode to use.

Set the day selection mode used.

Parameters

  [in] | mode | The select mode to use.

Referenced by elm_calendar_select_mode_set().

EOAPI Elm_Calendar_Selectable elm_obj_calendar_selectable_get | ( | void |  | ) |

Get how elm_calendar_selected_time_set manage a date.

Returns
  The flag used to manage a date with a elm_calendar_selected_time_set

See also
  elm_calendar_selectable_set
  elm_calendar_selected_time_set

Since
  1.8

Referenced by elm_calendar_selectable_get().

EOAPI void elm_obj_calendar_selectable_set | ( | Elm_Calendar_Selectable | selectable | ) |

Define which fields of a tm struct will be taken into account, when elm_calendar_selected_time_set() is invoked.

By Default the bitmask is set to use all fields of a tm struct (year, month and day of the month).

See also
  elm_calendar_selected_time_set

Since
  1.8

Parameters

  [in] | selectable | A bitmask of Elm_Calendar_Selectable

Referenced by elm_calendar_selectable_set().

EOAPI Eina_Bool elm_obj_calendar_selected_time_get | ( | struct tm * | selected_time | ) |

Get selected date.

Returns
  EINA_FALSE means an error occurred and returned time shouldn't be considered.

Get date selected by the user or set by function elm_calendar_selected_time_set(). Selected date changes when the user goes to next/previous month or select a day pressing over it on calendar.

See also
  elm_calendar_selected_time_get()

Calendar - Signal callback and getters.

Parameters

  [in,out] | selected_time | A tm struct to point to selected date

Referenced by elm_calendar_selected_time_get().

EOAPI void elm_obj_calendar_selected_time_set | ( | struct tm * | selected_time | ) |

Set selected date to be highlighted on calendar.

Set the selected date, changing the displayed month if needed. Selected date changes when the user goes to next/previous month or select a day pressing over it on calendar.

See also
  elm_calendar_selected_time_get()

Calendar - Days selection.

Parameters

  [in] | selected_time | A tm struct to represent the selected date.

Referenced by elm_calendar_selected_time_set().

EOAPI const char** elm_obj_calendar_weekdays_names_get | ( | void |  | ) |

Get weekdays names displayed by the calendar.

Returns
  Array of seven strings to be used as weekday names.

By default, weekdays abbreviations get from system are displayed: E.g. for an en_US locale: "Sun, Mon, Tue, Wed, Thu, Fri, Sat" The first string is related to Sunday, the second to Monday...

See also
  elm_calendar_weekdays_name_set()

Calendar - Signal callback and getters.

Referenced by elm_calendar_weekdays_names_get().

EOAPI void elm_obj_calendar_weekdays_names_set | ( | const char ** | weekdays | ) |

Set weekdays names to be displayed by the calendar.

By default, weekdays abbreviations get from system are displayed: E.g. for an en_US locale: "Sun, Mon, Tue, Wed, Thu, Fri, Sat"

The first string should be related to Sunday, the second to Monday...

The usage should be like this:

1 const char *weekdays[] =
2 {
3 "Sunday", "Monday", "Tuesday", "Wednesday",
4 "Thursday", "Friday", "Saturday"
5 };
6 elm_calendar_weekdays_names_set(calendar, weekdays);

See also
  elm_calendar_weekdays_name_get()

Calendar - Layout strings formatting.

Parameters

  [in] | weekdays | Array of seven strings to be used as weekday names.

Warning
  It must have 7 elements, or it will access invalid memory.
  The strings must be NULL terminated ('\0').

Referenced by elm_calendar_weekdays_names_set().